#include <generate-library-dependencies-la-object.hpp>

static
void frontend_dependency_1( std::deque<std::string>& libs, std::deque<std::string>& ldflags, std::deque<std::string>& rpaths, std::deque<std::string>& dependency_las, map< std::string, la_object>* la_objects )
{
    libs.clear();
    ldflags.clear();
    rpaths.clear();
    dependency_las.clear();
    libs.push_back( "-lGL" );
    libs.push_back( "-lpthread" );
    libs.push_back( "-lcube4" );
    libs.push_back( "-lz" );
    libs.push_back( "-lQt5PrintSupport" );
    libs.push_back( "-lQt5Widgets" );
    libs.push_back( "-lQt5Gui" );
    libs.push_back( "-lQt5Network" );
    libs.push_back( "-lQt5Concurrent" );
    libs.push_back( "-lQt5Core" );
    libs.push_back( "-lQt5WebEngineWidgets" );
    ldflags.push_back( "-L/usr/src/RPM/BUILD/cubelib-4.5/inst/usr/lib64" );
    rpaths.push_back( "-R/usr/src/RPM/BUILD/cubelib-4.5/inst/usr/lib64" );
    if ( la_objects->find( "libcube4gui" ) == la_objects->end() )
    {
        (*la_objects)[ "libcube4gui" ] =
            la_object( "libcube4gui",
                       "/usr/src/RPM/BUILD/cubegui-4.5/build-frontend",
                       "/usr/lib64",
                       libs,
                       ldflags,
                       rpaths,
                       dependency_las );
    }
}

static
void frontend_dependency_2( std::deque<std::string>& libs, std::deque<std::string>& ldflags, std::deque<std::string>& rpaths, std::deque<std::string>& dependency_las, map< std::string, la_object>* la_objects )
{
    libs.clear();
    ldflags.clear();
    rpaths.clear();
    dependency_las.clear();
    libs.push_back( "-ldbus-1" );
    libs.push_back( "-lGL" );
    libs.push_back( "-lpthread" );
    libs.push_back( "-lcube4" );
    libs.push_back( "-lz" );
    libs.push_back( "-lQt5PrintSupport" );
    libs.push_back( "-lQt5Widgets" );
    libs.push_back( "-lQt5Gui" );
    libs.push_back( "-lQt5Network" );
    libs.push_back( "-lQt5Concurrent" );
    libs.push_back( "-lQt5Core" );
    libs.push_back( "-lQt5WebEngineWidgets" );
    ldflags.push_back( "-L/usr/src/RPM/BUILD/cubelib-4.5/inst/usr/lib64" );
    rpaths.push_back( "-R/usr/src/RPM/BUILD/cubelib-4.5/inst/usr/lib64" );
    dependency_las.push_back( "libcube4gui" );
    if ( la_objects->find( "libgraphwidgetcommon-plugin" ) == la_objects->end() )
    {
        (*la_objects)[ "libgraphwidgetcommon-plugin" ] =
            la_object( "libgraphwidgetcommon-plugin",
                       "/usr/src/RPM/BUILD/cubegui-4.5/build-frontend",
                       "/usr/lib64",
                       libs,
                       ldflags,
                       rpaths,
                       dependency_las );
    }
}

static
void frontend_dependency_3( std::deque<std::string>& libs, std::deque<std::string>& ldflags, std::deque<std::string>& rpaths, std::deque<std::string>& dependency_las, map< std::string, la_object>* la_objects )
{
    libs.clear();
    ldflags.clear();
    rpaths.clear();
    dependency_las.clear();
    libs.push_back( "-lGL" );
    libs.push_back( "-lpthread" );
    libs.push_back( "-lcube4" );
    libs.push_back( "-lz" );
    libs.push_back( "-lQt5PrintSupport" );
    libs.push_back( "-lQt5Widgets" );
    libs.push_back( "-lQt5Gui" );
    libs.push_back( "-lQt5Network" );
    libs.push_back( "-lQt5Concurrent" );
    libs.push_back( "-lQt5Core" );
    libs.push_back( "-lQt5WebEngineWidgets" );
    ldflags.push_back( "-L/usr/src/RPM/BUILD/cubelib-4.5/inst/usr/lib64" );
    rpaths.push_back( "-R/usr/src/RPM/BUILD/cubelib-4.5/inst/usr/lib64" );
    if ( la_objects->find( "libcube4gui" ) == la_objects->end() )
    {
        (*la_objects)[ "libcube4gui" ] =
            la_object( "libcube4gui",
                       "/usr/src/RPM/BUILD/cubegui-4.5/build-frontend",
                       "/usr/lib64",
                       libs,
                       ldflags,
                       rpaths,
                       dependency_las );
    }
}

static
void add_library_dependencies_frontend( std::deque<std::string>& libs, std::deque<std::string>& ldflags, std::deque<std::string>& rpaths, std::deque<std::string>& dependency_las, std::map< std::string, la_object>* la_objects )
{
    frontend_dependency_1( libs, ldflags, rpaths, dependency_las, la_objects );
    frontend_dependency_2( libs, ldflags, rpaths, dependency_las, la_objects );
    frontend_dependency_3( libs, ldflags, rpaths, dependency_las, la_objects );
}
